// Class QButton 
// Generic Button. Generates OnPress event if clicked or space bar pressed
// Filename QButton.cpp
// FaPra 2003-2004, A5,  Alexander Kramer


#include "QButton.h"
#include <iostream>
using namespace std;

// ----------------------------------------------------------

//! draws itself with OpenGL. Here is the OpenGL drawing code
void QButton::draw( QEvent*  e )
{
 //
} // end of draw()

//! layout the children widgets. This method is called every time the size is changed. Have to be overwritten for respond on size changes
void QButton::layout()
{
} // end of layout()

//! have to return true if widget should be dragged with mouse. This method is overwritten in sub classes. If returns true, widget will be dragged
bool QButton::canDrag( QEvent*  e )
{
 return false;
} // end of canDrag()

//! processing mouse/keyboard events which are in widgets region. Mouse coordinates are relative to Owner
bool QButton::processEvent( QEvent*  e )
{
 
  if (e->getType() == etMouseDown)
  {
     if (e->getButton() == mbLeft)
     {
      State = bsDown;

     }
  }
  else  if (e->getType() == etMouseUp)
   {
     if ((e->getButton() == mbLeft) && (State == bsDown))
      {
         State = bsUp;
         if (onPress) (*onPress)(this,e);
      }
   }
  else if (e->getType() == etKeyboard)
  {
     if ((e->getKey() == 32) || (e->getKey() == 13))
     {
       State = bsDown;
     }
  }
  else if (e->getType() == etKeyboardUp)
   {
     if ((e->getKey() == 32) || (e->getKey() == 13))
     {
        State = bsUp;
        if (onPress) (*onPress)(this,e);
     }
   }
  return false;
} // end of processEvent()

//! processing mouse events which are in Owner widget region. Mouse coordinates are relative to Owner
bool QButton::processMouseOwner( QEvent*  e )
{
  if (State == bsDown)
   {
     if ((e->getX() < Left) || (e->getX() > Left+Width) || (e->getY() < Top) || (e->getY() > Top+Height)
        )
       State = bsUp;
   }
 return false;
} // end of processMouseOwner()

//! called if a child is added/removed
void QButton::childrenChanged()
{
} // end of childrenChanged()

//! defines whether control can have keyboard focus. Should return true if Widget wants to get keyboard focus
bool QButton::canFocus( QEvent*  e )
{
 return true;
} // end of canFocus()

//! initialization code
void QButton::Init()
{
} // end of Init()

//! clean up code
void QButton::CleanUp()
{
} // end of CleanUp()

//! getter method for State
QBevelState QButton::getState()
{
return State;
} // end of getState()

//! setter method for State
void QButton::setState( QBevelState  newValue )
{
State = newValue;
} // end of setState()

// WARNING : The implementation of this method will be automatically generated with code generator.
// To prevent this add '//KEEP' at the first line of the implementation.(first line after '{')
//! prints itself to the cout
void QButton::print()
{
cout << "Class : QButton" << endl;
cout << "State = " << State << endl;
} // end of print()

// WARNING : The implementation of this method will be automatically generated with code generator.
// To prevent this add '//KEEP' at the first line of the implementation.(first line after '{')
//! Constructor
 QButton::QButton( QWidget*  aOwner ):QWidget(aOwner)
{
onPress = 0;
State = bsUp;
Init();
layout();
} // end of QButton()

// WARNING : The implementation of this method will be automatically generated with code generator.
// To prevent this add '//KEEP' at the first line of the implementation.(first line after '{')
//! Destructor
 QButton::~QButton()
{
CleanUp();
} // end of ~QButton()

// end of implementation of QButton


