// Class QEvent 
// Filename QEvent.h 
// FaPra 2003-2004, A5, Alexander Kramer

#ifndef QEvent_h 
#define QEvent_h 


//! Pre-declaration of QEvent
class QEvent;


//! enumeration of events
enum QEventType {etDraw, etMouseDown, etMouseUp, etMouseMotion, etMouseClick, etKeyboard, etKeyboardUp, etSpecialKey };

//! enumeration of mouse buttons
enum QMouseButton {mbLeft, mbCenter, mbRight};


//! Event class, which holds the events
class QEvent
{
protected:
//! type of event
QEventType Type;

//! mouse button
QMouseButton Button;

//! mouse button x coordinate
int X;

//! mouse button y coordinate
int Y;

//! keyboard key
int Key;

public:
//! getter method for Type
virtual QEventType getType();

//! setter method for Type
virtual void setType( QEventType  newValue );

//! getter method for Button
virtual QMouseButton getButton();

//! setter method for Button
virtual void setButton( QMouseButton  newValue );

//! getter method for X
virtual int getX();

//! setter method for X
virtual void setX( int  newValue );

//! getter method for Y
virtual int getY();

//! setter method for Y
virtual void setY( int  newValue );

//! getter method for Key
virtual int getKey();

//! setter method for Key
virtual void setKey( int  newValue );

//! copy itself from another instance
 void copyFrom( QEvent*  from );

//! prints itself to the cout
 void print();

//! Constructor
  QEvent(  );

//! Destructor
virtual  ~QEvent();


};
#endif

