// Class QFont 
// Filename QFont.h 
// FaPra 2003-2004, A5, Alexander Kramer

#ifndef QFont_h 
#define QFont_h 


//! Pre-declaration of QFont
class QFont;


#include "QColor.h"
#include <string>

//! Font class for drawing text
class QFont
{
protected:
//! Font size
int Size;

//! defines whether font is bold
bool Bold;

//! color of the font
QColor* Color;

public:
//! draws the text with maximum length)
 void draw( const  char*  aText , int  maxLength );

//! draws the text and ajust the matrix
 void drawInternal( const  char*  aText , int  maxLength );

//! draws the text at given position
 void drawAtPos( const  char*  aText , int  x , int  y , int  maxLength );

//! returns width of text
 float getTextWidth( const  char*  aText );

//! returns length of string which can be drawn whithin the given width
 int getLengthForWidth( const  char*  aText , int  aWidth );

//! initialization code
virtual void Init();

//! clean up code
virtual void CleanUp();

//! getter method for Size
virtual int getSize();

//! setter method for Size
virtual void setSize( int  newValue );

//! getter method for Bold
virtual bool getBold();

//! setter method for Bold
virtual void setBold( bool  newValue );

//! getter method for Color
 QColor* getColor();

//! copy itself from another instance
 void copyFrom( QFont*  from );

//! prints itself to the cout
 void print();

//! Constructor
  QFont(  );

//! Destructor
virtual  ~QFont();


};
#endif

