// Class QTextEdit 
// Filename QTextEdit.h 
// FaPra 2003-2004, A5, Alexander Kramer

#ifndef QTextEdit_h 
#define QTextEdit_h 


//! Pre-declaration of QTextEdit
class QTextEdit;


#include "QFont.h"
#include "QWidget.h"

//! Text edit widget
class QTextEdit : public QWidget
{
protected:
//! cursor Position
int CursorPos;

//! text property
string Text;

//! widget for drawing text
QFont* Font;

public:
//! draws itself with OpenGL. Here is the OpenGL drawing code
virtual void draw( QEvent*  e );

//! layout the children widgets. This method is called every time the size is changed. Have to be overwritten for respond on size changes
virtual void layout();

//! have to return true if widget should be dragged with mouse. This method is overwritten in sub classes. If returns true, widget will be dragged
virtual bool canDrag( QEvent*  e );

//! processing mouse/keyboard events which are in widgets region. Mouse coordinates are relative to Owner
virtual bool processEvent( QEvent*  e );

//! processing mouse events which are in Owner widget region. Mouse coordinates are relative to Owner
virtual bool processMouseOwner( QEvent*  e );

//! called if a child is added/removed
virtual void childrenChanged();

//! defines whether control can have keyboard focus. Should return true if Widget wants to get keyboard focus
virtual bool canFocus( QEvent*  e );

//! initialization code
virtual void Init();

//! clean up code
virtual void CleanUp();

//! getter method for CursorPos
virtual int getCursorPos();

//! setter method for CursorPos
virtual void setCursorPos( int  newValue );

//! getter method for Text
virtual string getText();

//! setter method for Text
virtual void setText( string  newValue );

//! getter method for Font
 QFont* getFont();

//! prints itself to the cout
 void print();

//! Constructor
  QTextEdit( QWidget*  aOwner );

//! Destructor
virtual  ~QTextEdit();


};
#endif

